﻿unit mtp_main;

interface

//*******************************************************************
//Created by sinisav (dec. 2013, feb. 2014) (http://www.experts-exchange.com/M_6334433.html)
//*******************************************************************

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, PortableDeviceApiLib_TLB, ActiveX, ComObj, ComCtrls;

// based upon following texts:

// http://cgeers.com/2011/05/22/enumerating-windows-portable-devices/
// http://cgeers.com/2011/06/05/wpd-enumerating-content/
// http://chocotooth.blogspot.com/2011/05/controlling-digital-camera-with-delphi_10.html
// http://chocotooth.blogspot.com/2011/07/controlling-digital-camera-with-delphi.html
// https://github.com/notpod/wpd-lib/blob/master/wpd-lib/WindowsPortableDevice.cs
// http://gzune.googlecode.com/svn/trunk/zUnlock/portabledeviceconstants.cs

// http://msdn.microsoft.com/en-us/library/ff597727.aspx

const
  DEV_START_PATH : WideString = '\\?\';

const
  CLASS_PortableDeviceValues: TGUID = '{0c15d503-d017-47ce-9016-7b3f978721cc}';
  CLASS_PortableDevicePropVariantCollection: TGUID = '{08a99e2f-6d6d-4b80-af5a-baf2bcbe4cb9}';
  CLSID_PortableDeviceKeyCollection: TGUID = '{de2d022d-2480-43be-97f0-d1fa2cf98f4f}';

const
  GUID_DEVINTERFACE_WPD : TGuid = '{6ac27878-a6fa-4155-ba85-f98f491d4f33}';
  GUID_DEVINTERFACE_WPD_PRIVATE : TGuid = '{ba0c718f-4ded-49b7-bdd3-fabe28661211}';
  GUID_DEVINTERFACE_WPD_SERVICE : TGuid = '{9ef44f80-3d64-4246-a6aa-206f328d1edc}';
  WPD_API_OPTIONS_V1 : TGuid = '{10e54a3e-052d-4777-a13c-de7614be2bc4}';
  WPD_APPOINTMENT_OBJECT_PROPERTIES_V1 : TGuid = '{f99efd03-431d-40d8-a1c9-4e220d9c88d3}';
  WPD_CATEGORY_CAPABILITIES : TGuid = '{0cabec78-6b74-41c6-9216-2639d1fce356}';
  WPD_CATEGORY_COMMON : TGuid = '{f0422a9c-5dc8-4440-b5bd-5df28835658a}';
  WPD_CATEGORY_DEVICE_HINTS : TGuid = '{0d5fb92b-cb46-4c4f-8343-0bc3d3f17c84}';
  WPD_CATEGORY_MEDIA_CAPTURE : TGuid = '{59b433ba-fe44-4d8d-808c-6bcb9b0f15e8}';
  WPD_CATEGORY_NETWORK_CONFIGURATION : TGuid = '{78f9c6fc-79b8-473c-9060-6bd23dd072c4}';
  WPD_CATEGORY_NULL : TGuid = '{00000000-0000-0000-0000-000000000000}';
  WPD_CATEGORY_OBJECT_ENUMERATION : TGuid = '{b7474e91-e7f8-4ad9-b400-ad1a4b58eeec}';
  WPD_CATEGORY_OBJECT_MANAGEMENT : TGuid = '{ef1e43dd-a9ed-4341-8bcc-186192aea089}';
  WPD_CATEGORY_OBJECT_PROPERTIES : TGuid = '{9e5582e4-0814-44e6-981a-b2998d583804}';
  WPD_CATEGORY_OBJECT_PROPERTIES_BULK : TGuid = '{11c824dd-04cd-4e4e-8c7b-f6efb794d84e}';
  WPD_CATEGORY_OBJECT_RESOURCES : TGuid = '{b3a2b22d-a595-4108-be0a-fc3c965f3d4a}';
  WPD_CATEGORY_SERVICE_CAPABILITIES : TGuid = '{24457e74-2e9f-44f9-8c57-1d1bcb170b89}';
  WPD_CATEGORY_SERVICE_COMMON : TGuid = '{322f071d-36ef-477f-b4b5-6f52d734baee}';
  WPD_CATEGORY_SERVICE_METHODS : TGuid = '{2d521ca8-c1b0-4268-a342-cf19321569bc}';
  WPD_CATEGORY_SMS : TGuid = '{afc25d66-fe0d-4114-9097-970c93e920d1}';
  WPD_CATEGORY_STILL_IMAGE_CAPTURE : TGuid = '{4fcd6982-22a2-4b05-a48b-62d38bf27b32}';
  WPD_CATEGORY_STORAGE : TGuid = '{d8f907a6-34cc-45fa-97fb-d007fa47ec94}';
  WPD_CLASS_EXTENSION_OPTIONS_V1 : TGuid = '{6309ffef-a87c-4ca7-8434-797576e40a96}';
  WPD_CLASS_EXTENSION_OPTIONS_V2 : TGuid = '{3e3595da-4d71-49fe-a0b4-d4406c3ae93f}';
  WPD_CLASS_EXTENSION_V1 : TGuid = '{33fb0d11-64a3-4fac-b4c7-3dfeaa99b051}';
  WPD_CLASS_EXTENSION_V2 : TGuid = '{7f0779b5-fa2b-4766-9cb2-f73ba30b6758}';
  WPD_CLIENT_INFORMATION_PROPERTIES_V1 : TGuid = '{204d9f0c-2292-4080-9f42-40664e70f859}';
  WPD_COMMON_INFORMATION_OBJECT_PROPERTIES_V1 : TGuid = '{b28ae94b-05a4-4e8e-be01-72cc7e099d8f}';
  WPD_PROPERTY_COMMON_COMMAND_CATEGORY : TGuid = '{4d545058-1a2e-4106-a357-771e0819fc56}';
  WPD_CONTACT_OBJECT_PROPERTIES_V1 : TGuid = '{fbd4fdab-987d-4777-b3f9-726185a9312b}';
  WPD_CONTENT_TYPE_ALL : TGuid = '{80e170d2-1055-4a3e-b952-82cc4f8a8689}';
  WPD_CONTENT_TYPE_APPOINTMENT : TGuid = '{0fed060e-8793-4b1e-90c9-48ac389ac631}';
  WPD_CONTENT_TYPE_AUDIO : TGuid = '{4ad2c85e-5e2d-45e5-8864-4f229e3c6cf0}';
  WPD_CONTENT_TYPE_AUDIO_ALBUM : TGuid = '{aa18737e-5009-48fa-ae21-85f24383b4e6}';
  WPD_CONTENT_TYPE_CALENDAR : TGuid = '{a1fd5967-6023-49a0-9df1-f8060be751b0}';
  WPD_CONTENT_TYPE_CERTIFICATE : TGuid = '{dc3876e8-a948-4060-9050-cbd77e8a3d87}';
  WPD_CONTENT_TYPE_CONTACT : TGuid = '{eaba8313-4525-4707-9f0e-87c6808e9435}';
  WPD_CONTENT_TYPE_CONTACT_GROUP : TGuid = '{346b8932-4c36-40d8-9415-1828291f9de9}';
  WPD_CONTENT_TYPE_DOCUMENT : TGuid = '{680adf52-950a-4041-9b41-65e393648155}';
  WPD_CONTENT_TYPE_EMAIL : TGuid = '{8038044a-7e51-4f8f-883d-1d0623d14533}';
  WPD_CONTENT_TYPE_FUNCTIONAL_OBJECT : TGuid = '{99ed0160-17ff-4c44-9d98-1d7a6f941921}';
  WPD_CONTENT_TYPE_GENERIC_FILE : TGuid = '{0085e0a6-8d34-45d7-bc5c-447e59c73d48}';
  WPD_CONTENT_TYPE_GENERIC_MESSAGE : TGuid = '{e80eaaf8-b2db-4133-b67e-1bef4b4a6e5f}';
  WPD_CONTENT_TYPE_IMAGE : TGuid = '{ef2107d5-a52a-4243-a26b-62d4176d7603}';
  WPD_CONTENT_TYPE_IMAGE_ALBUM : TGuid = '{75793148-15f5-4a30-a813-54ed8a37e226}';
  WPD_CONTENT_TYPE_MEDIA_CAST : TGuid = '{5e88b3cc-3e65-4e62-bfff-229495253ab0}';
  WPD_CONTENT_TYPE_MEMO : TGuid = '{9cd20ecf-3b50-414f-a641-e473ffe45751}';
  WPD_CONTENT_TYPE_MIXED_CONTENT_ALBUM : TGuid = '{00f0c3ac-a593-49ac-9219-24abca5a2563}';
  WPD_CONTENT_TYPE_NETWORK_ASSOCIATION : TGuid = '{031da7ee-18c8-4205-847e-89a11261d0f3}';
  WPD_CONTENT_TYPE_PLAYLIST : TGuid = '{1a33f7e4-af13-48f5-994e-77369dfe04a3}';
  WPD_CONTENT_TYPE_PROGRAM : TGuid = '{d269f96a-247c-4bff-98fb-97f3c49220e6}';
  WPD_CONTENT_TYPE_SECTION : TGuid = '{821089f5-1d91-4dc9-be3c-bbb1b35b18ce}';
  WPD_CONTENT_TYPE_TASK : TGuid = '{63252f2c-887f-4cb6-b1ac-d29855dcef6c}';
  WPD_CONTENT_TYPE_TELEVISION : TGuid = '{60a169cf-f2ae-4e21-9375-9677f11c1c6e}';
  WPD_CONTENT_TYPE_UNSPECIFIED : TGuid = '{28d8d31e-249c-454e-aabc-34883168e634}';
  WPD_CONTENT_TYPE_VIDEO : TGuid = '{9261b03c-3d78-4519-85e3-02c5e1f50bb9}';
  WPD_CONTENT_TYPE_VIDEO_ALBUM : TGuid = '{012b0db7-d4c1-45d6-b081-94b87779614f}';
  WPD_CONTENT_TYPE_WIRELESS_PROFILE : TGuid = '{0bac070a-9f5f-4da4-a8f6-3de44d68fd6c}';
  WPD_CONTENT_TYPE_FOLDER : TGuid = '{27E2E392-A111-48E0-AB0C-E17705A05F85}';
  WPD_DEVICE_PROPERTIES_V1 : TGuid = '{26d4979a-e643-4626-9e2b-736dc0c92fdc}';
  WPD_DEVICE_PROPERTIES_V2 : TGuid = '{463dd662-7fc4-4291-911c-7f4c9cca9799}';
  WPD_DOCUMENT_OBJECT_PROPERTIES_V1 : TGuid = '{0b110203-eb95-4f02-93e0-97c631493ad5}';
  WPD_EMAIL_OBJECT_PROPERTIES_V1 : TGuid = '{41f8f65a-5484-4782-b13d-4740dd7c37c5}';
  WPD_EVENT_ATTRIBUTES_V1 : TGuid = '{10c96578-2e81-4111-adde-e08ca6138f6d}';
  WPD_EVENT_DEVICE_CAPABILITIES_UPDATED : TGuid = '{36885aa1-cd54-4daa-b3d0-afb3e03f5999}';
  WPD_EVENT_DEVICE_REMOVED : TGuid = '{e4cbca1b-6918-48b9-85ee-02be7c850af9}';
  WPD_EVENT_DEVICE_RESET : TGuid = '{7755cf53-c1ed-44f3-b5a2-451e2c376b27}';
  WPD_EVENT_OBJECT_ADDED : TGuid = '{a726da95-e207-4b02-8d44-bef2e86cbffc}';
  WPD_EVENT_OBJECT_REMOVED : TGuid = '{be82ab88-a52c-4823-96e5-d0272671fc38}';
  WPD_EVENT_OBJECT_TRANSFER_REQUESTED : TGuid = '{8d16a0a1-f2c6-41da-8f19-5e53721adbf2}';
  WPD_EVENT_OBJECT_UPDATED : TGuid = '{1445a759-2e01-485d-9f27-ff07dae697ab}';
  WPD_EVENT_OPTIONS_V1 : TGuid = '{b3d8dad7-a361-4b83-8a48-5b02ce10713b}';
  WPD_EVENT_PROPERTIES_V1 : TGuid = '{15ab1953-f817-4fef-a921-5676e838f6e0}';
  WPD_EVENT_PROPERTIES_V2 : TGuid = '{52807b8a-4914-4323-9b9a-74f654b2b846}';
  WPD_EVENT_SERVICE_METHOD_COMPLETE : TGuid = '{8a33f5f8-0acc-4d9b-9cc4-112d353b86ca}';
  WPD_EVENT_STORAGE_FORMAT : TGuid = '{3782616b-22bc-4474-a251-3070f8d38857}';
  WPD_FOLDER_OBJECT_PROPERTIES_V1 : TGuid = '{7e9a7abf-e568-4b34-aa2f-13bb12ab177d}';
  WPD_FORMAT_ATTRIBUTES_V1 : TGuid = '{a0a02000-bcaf-4be8-b3f5-233f231cf58f}';
  WPD_FUNCTIONAL_CATEGORY_ALL : TGuid = '{2d8a6512-a74c-448e-ba8a-f4ac07c49399}';
  WPD_FUNCTIONAL_CATEGORY_AUDIO_CAPTURE : TGuid = '{3f2a1919-c7c2-4a00-855d-f57cf06debbb}';
  WPD_FUNCTIONAL_CATEGORY_DEVICE : TGuid = '{08ea466b-e3a4-4336-a1f3-a44d2b5c438c}';
  WPD_FUNCTIONAL_CATEGORY_NETWORK_CONFIGURATION : TGuid = '{48f4db72-7c6a-4ab0-9e1a-470e3cdbf26a}';
  WPD_FUNCTIONAL_CATEGORY_RENDERING_INFORMATION : TGuid = '{08600ba4-a7ba-4a01-ab0e-0065d0a356d3}';
  WPD_FUNCTIONAL_CATEGORY_SMS : TGuid = '{0044a0b1-c1e9-4afd-b358-a62c6117c9cf}';
  WPD_FUNCTIONAL_CATEGORY_STILL_IMAGE_CAPTURE : TGuid = '{613ca327-ab93-4900-b4fa-895bb5874b79}';
  WPD_FUNCTIONAL_CATEGORY_STORAGE : TGuid = '{23f05bbc-15de-4c2a-a55b-a9af5ce412ef}';
  WPD_FUNCTIONAL_CATEGORY_VIDEO_CAPTURE : TGuid = '{e23e5f6b-7243-43aa-8df1-0eb3d968a918}';
  WPD_FUNCTIONAL_OBJECT_PROPERTIES_V1 : TGuid = '{8f052d93-abca-4fc5-a5ac-b01df4dbe598}';
  WPD_IMAGE_OBJECT_PROPERTIES_V1 : TGuid = '{63d64908-9fa1-479f-85ba-9952216447db}';
  WPD_MEDIA_PROPERTIES_V1 : TGuid = '{2ed8ba05-0ad3-42dc-b0d0-bc95ac396ac8}';
  WPD_MEMO_OBJECT_PROPERTIES_V1 : TGuid = '{5ffbfc7b-7483-41ad-afb9-da3f4e592b8d}';
  WPD_METHOD_ATTRIBUTES_V1 : TGuid = '{f17a5071-f039-44af-8efe-432cf32e432a}';
  WPD_MUSIC_OBJECT_PROPERTIES_V1 : TGuid = '{b324f56a-dc5d-46e5-b6df-d2ea414888c6}';
  WPD_NETWORK_ASSOCIATION_PROPERTIES_V1 : TGuid = '{e4c93c1f-b203-43f1-a100-5a07d11b0274}';
  WPD_OBJECT_FORMAT_3GP : TGuid = '{b9840000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_AAC : TGuid = '{b9030000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_ABSTRACT_CONTACT : TGuid = '{bb810000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_ABSTRACT_CONTACT_GROUP : TGuid = '{ba060000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_ABSTRACT_MEDIA_CAST : TGuid = '{ba0b0000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_AIFF : TGuid = '{30070000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_ALL : TGuid = '{c1f62eb2-4bb3-479c-9cfa-05b5f3a57b22}';
  WPD_OBJECT_FORMAT_ASF : TGuid = '{300c0000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_ASXPLAYLIST : TGuid = '{ba130000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_AUDIBLE : TGuid = '{b9040000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_AVI : TGuid = '{300a0000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_BMP : TGuid = '{38040000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_CIFF : TGuid = '{38050000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_DPOF : TGuid = '{30060000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_EXECUTABLE : TGuid = '{30030000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_EXIF : TGuid = '{38010000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_FLAC : TGuid = '{b9060000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_FLASHPIX : TGuid = '{38030000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_GIF : TGuid = '{38070000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_HTML : TGuid = '{30050000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_ICALENDAR : TGuid = '{be030000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_ICON : TGuid = '{077232ed-102c-4638-9c22-83f142bfc822}';
  WPD_OBJECT_FORMAT_JFIF : TGuid = '{38080000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_JP2 : TGuid = '{380f0000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_JPX : TGuid = '{38100000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_M3UPLAYLIST : TGuid = '{ba110000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_M4A : TGuid = '{30aba7ac-6ffd-4c23-a359-3e9b52f3f1c8}';
  WPD_OBJECT_FORMAT_MHT_COMPILED_HTML : TGuid = '{ba840000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_MICROSOFT_EXCEL : TGuid = '{ba850000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_MICROSOFT_POWERPOINT : TGuid = '{ba860000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_MICROSOFT_WFC : TGuid = '{b1040000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_MICROSOFT_WORD : TGuid = '{ba830000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_MP2 : TGuid = '{b9830000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_MP3 : TGuid = '{30090000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_MP4 : TGuid = '{b9820000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_MPEG : TGuid = '{300b0000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_MPLPLAYLIST : TGuid = '{ba120000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_NETWORK_ASSOCIATION : TGuid = '{b1020000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_OGG : TGuid = '{b9020000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_PCD : TGuid = '{38090000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_PICT : TGuid = '{380a0000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_PLSPLAYLIST : TGuid = '{ba140000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_PNG : TGuid = '{380b0000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_PROPERTIES_ONLY : TGuid = '{30010000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_SCRIPT : TGuid = '{30020000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_TEXT : TGuid = '{30040000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_TIFF : TGuid = '{380d0000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_TIFFEP : TGuid = '{38020000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_TIFFIT : TGuid = '{380e0000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_UNSPECIFIED : TGuid = '{30000000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_VCALENDAR1 : TGuid = '{be020000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_VCARD2 : TGuid = '{bb820000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_VCARD3 : TGuid = '{bb830000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_WAVE : TGuid = '{30080000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_WINDOWSIMAGEFORMAT : TGuid = '{b8810000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_WMA : TGuid = '{b9010000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_WMV : TGuid = '{b9810000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_WPLPLAYLIST : TGuid = '{ba100000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_X509V3CERTIFICATE : TGuid = '{b1030000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_FORMAT_XML : TGuid = '{ba820000-ae6c-4804-98ba-c57b46965fe7}';
  WPD_OBJECT_PROPERTIES_V1 : TGuid = '{ef6b490d-5cd8-437a-affc-da8b60ee4a3c}';
  WPD_PARAMETER_ATTRIBUTES_V1 : TGuid = '{e6864dd7-f325-45ea-a1d5-97cf73b6ca58}';
  WPD_PROPERTY_ATTRIBUTES_V1 : TGuid = '{ab7943d8-6332-445f-a00d-8d5ef1e96f37}';
  WPD_PROPERTY_ATTRIBUTES_V2 : TGuid = '{5d9da160-74ae-43cc-85a9-fe555a80798e}';
  WPD_RENDERING_INFORMATION_OBJECT_PROPERTIES_V1 : TGuid = '{c53d039f-ee23-4a31-8590-7639879870b4}';
  WPD_RESOURCE_ATTRIBUTES_V1 : TGuid = '{1eb6f604-9278-429f-93cc-5bb8c06656b6}';
  WPD_SECTION_OBJECT_PROPERTIES_V1 : TGuid = '{516afd2b-c64e-44f0-98dc-bee1c88f7d66}';
  WPD_SERVICE_PROPERTIES_V1 : TGuid = '{7510698a-cb54-481c-b8db-0d75c93f1c06}';
  WPD_SMS_OBJECT_PROPERTIES_V1 : TGuid = '{7e1074cc-50ff-4dd1-a742-53be6f093a0d}';
  WPD_STILL_IMAGE_CAPTURE_OBJECT_PROPERTIES_V1 : TGuid = '{58c571ec-1bcb-42a7-8ac5-bb291573a260}';
  WPD_STORAGE_OBJECT_PROPERTIES_V1 : TGuid = '{01a3057a-74d6-4e80-bea7-dc4c212ce50a}';
  WPD_TASK_OBJECT_PROPERTIES_V1 : TGuid = '{e354e95e-d8a0-4637-a03a-0cb26838dbc7}';
  WPD_VIDEO_OBJECT_PROPERTIES_V1 : TGuid = '{346f2163-f998-4146-8b01-d19b4c00de9a}';


  WPD_PROPERTY_NULL_FMTID : TGuid = '{00000000-0000-0000-0000-000000000000}';
  WPD_PROPERTY_NULL_PID = 0;

  WPD_OBJECT_ID_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_ID_PID = 2;

  WPD_OBJECT_PARENT_ID_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_PARENT_ID_PID = 3;

  WPD_OBJECT_NAME_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_NAME_PID = 4;

  WPD_OBJECT_PERSISTENT_UNIQUE_ID_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_PERSISTENT_UNIQUE_ID_PID = 5;

  WPD_OBJECT_FORMAT_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_FORMAT_PID = 6;

  WPD_OBJECT_CONTENT_TYPE_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_CONTENT_TYPE_PID = 7;

  WPD_OBJECT_ISHIDDEN_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_ISHIDDEN_PID = 9;

  WPD_OBJECT_ISSYSTEM_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_ISSYSTEM_PID = 10;

  WPD_OBJECT_SIZE_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_SIZE_PID = 11;

  WPD_OBJECT_ORIGINAL_FILE_NAME_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_ORIGINAL_FILE_NAME_PID = 12;

  WPD_OBJECT_NON_CONSUMABLE_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_NON_CONSUMABLE_PID = 13;

  WPD_OBJECT_REFERENCES_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_REFERENCES_PID = 14;

  WPD_OBJECT_KEYWORDS_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_KEYWORDS_PID = 15;

  WPD_OBJECT_SYNC_ID_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_SYNC_ID_PID = 16;

  WPD_OBJECT_IS_DRM_PROTECTED_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_IS_DRM_PROTECTED_PID = 17;

  WPD_OBJECT_DATE_CREATED_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_DATE_CREATED_PID = 18;

  WPD_OBJECT_DATE_MODIFIED_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_DATE_MODIFIED_PID = 19;

  WPD_OBJECT_DATE_AUTHORED_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_DATE_AUTHORED_PID = 20;

  WPD_OBJECT_BACK_REFERENCES_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_BACK_REFERENCES_PID = 21;

  WPD_OBJECT_CONTAINER_FUNCTIONAL_OBJECT_ID_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_CONTAINER_FUNCTIONAL_OBJECT_ID_PID = 23;

  WPD_OBJECT_GENERATE_THUMBNAIL_FROM_RESOURCE_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_GENERATE_THUMBNAIL_FROM_RESOURCE_PID = 24;

  WPD_OBJECT_HINT_LOCATION_DISPLAY_NAME_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_HINT_LOCATION_DISPLAY_NAME_PID = 25;

  WPD_OBJECT_CAN_DELETE_FMTID : TGuid = '{EF6B490D-5CD8-437A-AFFC-DA8B60EE4A3C}';
  WPD_OBJECT_CAN_DELETE_PID = 26;


  WPD_CLIENT_NAME_FMTID : TGuid = '{204D9F0C-2292-4080-9F42-40664E70F859}';
  WPD_CLIENT_NAME_PID = 2;

  WPD_CLIENT_MAJOR_VERSION_FMTID : TGuid = '{204D9F0C-2292-4080-9F42-40664E70F859}';
  WPD_CLIENT_MAJOR_VERSION_PID = 3;

  WPD_CLIENT_MINOR_VERSION_FMTID : TGuid = '{204D9F0C-2292-4080-9F42-40664E70F859}';
  WPD_CLIENT_MINOR_VERSION_PID = 4;

  WPD_CLIENT_REVISION_FMTID : TGuid = '{204D9F0C-2292-4080-9F42-40664E70F859}';
  WPD_CLIENT_REVISION_PID = 5;

  WPD_CLIENT_DESIRED_ACCESS_FMTID : TGuid = '{204D9F0C-2292-4080-9F42-40664E70F859}';
  WPD_CLIENT_DESIRED_ACCESS_PID = 9;

  WPD_DEVICE_FRIENDLY_NAME_FMTID : TGuid = '{26D4979A-E643-4626-9E2B-736DC0C92FDC}';
  WPD_DEVICE_FRIENDLY_NAME_PID = 12;


  WPD_RESOURCE_DEFAULT_FMTID : TGuid = '{E81E79BE-34F0-41BF-B53F-F1A06AE87842}';
  WPD_RESOURCE_DEFAULT_PID = 0;


  WPD_PROPERTY_ATTRIBUTE_FORM_FMTID : TGuid = '{ab7943d8-6332-445f-a00d-8d5ef1e96f37}';
  WPD_PROPERTY_ATTRIBUTE_FORM_PID = 2;

  WPD_PROPERTY_ATTRIBUTE_CAN_READ_FMTID : TGuid = '{ab7943d8-6332-445f-a00d-8d5ef1e96f37}';
  WPD_PROPERTY_ATTRIBUTE_CAN_READ_PID = 3;

  WPD_PROPERTY_ATTRIBUTE_CAN_WRITE_FMTID : TGuid = '{ab7943d8-6332-445f-a00d-8d5ef1e96f37}';
  WPD_PROPERTY_ATTRIBUTE_CAN_WRITE_PID = 4;

  WPD_PROPERTY_ATTRIBUTE_CAN_DELETE_FMTID : TGuid = '{ab7943d8-6332-445f-a00d-8d5ef1e96f37}';
  WPD_PROPERTY_ATTRIBUTE_CAN_DELETE_PID = 5;

  WPD_PROPERTY_ATTRIBUTE_DEFAULT_VALUE_FMTID : TGuid = '{ab7943d8-6332-445f-a00d-8d5ef1e96f37}';
  WPD_PROPERTY_ATTRIBUTE_DEFAULT_VALUE_PID = 6;

  WPD_PROPERTY_ATTRIBUTE_FAST_PROPERTY_FMTID : TGuid = '{ab7943d8-6332-445f-a00d-8d5ef1e96f37}';
  WPD_PROPERTY_ATTRIBUTE_FAST_PROPERTY_PID = 7;

  WPD_PROPERTY_ATTRIBUTE_RANGE_MIN_FMTID : TGuid = '{ab7943d8-6332-445f-a00d-8d5ef1e96f37}';
  WPD_PROPERTY_ATTRIBUTE_RANGE_MIN_PID = 8;

  WPD_PROPERTY_ATTRIBUTE_RANGE_MAX_FMTID : TGuid = '{ab7943d8-6332-445f-a00d-8d5ef1e96f37}';
  WPD_PROPERTY_ATTRIBUTE_RANGE_MAX_PID = 9;

  WPD_PROPERTY_ATTRIBUTE_RANGE_STEP_FMTID : TGuid = '{ab7943d8-6332-445f-a00d-8d5ef1e96f37}';
  WPD_PROPERTY_ATTRIBUTE_RANGE_STEP_PID = 10;

  WPD_PROPERTY_ATTRIBUTE_ENUMERATION_ELEMENTS_FMTID : TGuid = '{ab7943d8-6332-445f-a00d-8d5ef1e96f37}';
  WPD_PROPERTY_ATTRIBUTE_ENUMERATION_ELEMENTS_PID = 11;

  WPD_PROPERTY_ATTRIBUTE_REGULAR_EXPRESSION_FMTID : TGuid = '{ab7943d8-6332-445f-a00d-8d5ef1e96f37}';
  WPD_PROPERTY_ATTRIBUTE_REGULAR_EXPRESSION_PID = 12;

  WPD_PROPERTY_ATTRIBUTE_MAX_SIZE_FMTID : TGuid = '{ab7943d8-6332-445f-a00d-8d5ef1e96f37}';
  WPD_PROPERTY_ATTRIBUTE_MAX_SIZE_PID = 13;


  WPD_DEVICE_OBJECT_ID = 'DEVICE';

(*

  WPD_CATEGORY_MTP_EXT_VENDOR_OPERATIONS = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56);
  WPD_PROPERTIES_MTP_VENDOR_EXTENDED_OBJECT_PROPS = new Guid(0x4d545058, 0x4fce, 0x4578, 0x95, 0xc8, 0x86, 0x98, 0xa9, 0xbc, 0xf, 0x49);
  WPD_PROPERTIES_MTP_VENDOR_EXTENDED_DEVICE_PROPS = new Guid(0x4d545058, 0x8900, 0x40b3, 0x8f, 0x1d, 0xdc, 0x24, 0x6e, 0x1e, 0x83, 0x70);
  WPD_EVENT_MTP_VENDOR_EXTENDED_EVENTS = new Guid(0x00000000, 0x5738, 0x4ff2, 0x84, 0x45, 0xbe, 0x31, 0x26, 0x69, 0x10, 0x59);

  WPD_COMMAND_MTP_EXT_GET_SUPPORTED_VENDOR_OPCODES = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 11 };
  WPD_COMMAND_MTP_EXT_EXECUTE_COMMAND_WITHOUT_DATA_PHASE = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 12 };
  WPD_COMMAND_MTP_EXT_EXECUTE_COMMAND_WITH_DATA_TO_READ = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 13 };
  WPD_COMMAND_MTP_EXT_EXECUTE_COMMAND_WITH_DATA_TO_WRITE = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 14 };
  WPD_COMMAND_MTP_EXT_READ_DATA = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 15 };
  WPD_COMMAND_MTP_EXT_WRITE_DATA = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 16 };
  WPD_COMMAND_MTP_EXT_END_DATA_TRANSFER = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 17 };
  WPD_COMMAND_MTP_EXT_GET_VENDOR_EXTENSION_DESCRIPTION = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 18 };
  WPD_PROPERTY_MTP_EXT_OPERATION_CODE = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1001 };
  WPD_PROPERTY_MTP_EXT_OPERATION_PARAMS = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1002 };
  WPD_PROPERTY_MTP_EXT_RESPONSE_CODE = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1003 };
  WPD_PROPERTY_MTP_EXT_RESPONSE_PARAMS = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1004 };
  WPD_PROPERTY_MTP_EXT_VENDOR_OPERATION_CODES = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1005 };
  WPD_PROPERTY_MTP_EXT_TRANSFER_CONTEXT = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1006 };
  WPD_PROPERTY_MTP_EXT_TRANSFER_TOTAL_DATA_SIZE = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1007 };
  WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_TO_READ = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1008 };
  WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_READ = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1009 };
  WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_TO_WRITE = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1010 };
  WPD_PROPERTY_MTP_EXT_TRANSFER_NUM_BYTES_WRITTEN = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1011 };
  WPD_PROPERTY_MTP_EXT_TRANSFER_DATA = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1012 };
  WPD_PROPERTY_MTP_EXT_OPTIMAL_TRANSFER_BUFFER_SIZE = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1013 };
  WPD_PROPERTY_MTP_EXT_VENDOR_EXTENSION_DESCRIPTION = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0x1a2e, 0x4106, 0xa3, 0x57, 0x77, 0x1e, 0x8, 0x19, 0xfc, 0x56), pid = 1014 };
  WPD_PROPERTY_MTP_EXT_EVENT_PARAMS = new _tagpropertykey() { fmtid = new Guid(0x4d545058, 0xef88, 0x4e4d, 0x95, 0xc3, 0x4f, 0x32, 0x7f, 0x72, 0x8a, 0x96), pid = 1011 };
*)

type
  TForm12 = class(TForm)
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    SaveDialog1: TSaveDialog;
    Button5: TButton;
    OpenDialog1: TOpenDialog;
    Button6: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    ListView1: TListView;
    Button7: TButton;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure ListView1Editing(Sender: TObject; Item: TListItem;
      var AllowEdit: Boolean);
    procedure Button7Click(Sender: TObject);
    procedure ListView1DrawItem(Sender: TCustomListView; Item: TListItem;
      Rect: TRect; State: TOwnerDrawState);
    procedure ListView1CustomDrawItem(Sender: TCustomListView; Item: TListItem;
      State: TCustomDrawState; var DefaultDraw: Boolean);
  private
    procedure AddLog(sText: String);
    procedure ClearLog;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form12: TForm12;

implementation

uses Math;

{$R *.dfm}

procedure TForm12.ClearLog;
begin
  Memo1.Lines.Clear;
end;

procedure TForm12.AddLog(sText: String);
begin
  if CheckBox1.Checked then  
    Memo1.Lines.Add(sText);
end;

procedure PropVariantInit(out pvar: PROPVARIANT);
begin
  ZeroMemory(@pvar, SizeOf(PROPVARIANT));
end;

procedure StringToPropVariant(sVal: WideString; var propvarValue: tag_inner_PROPVARIANT);
var
  pValues: IPortableDeviceValues;
  dev_val: PortableDeviceApiLib_TLB._tagpropertykey;
begin
  pValues :=  CreateComObject(CLASS_PortableDeviceValues) as IPortableDeviceValues;
  if VarIsClear(pValues) then Exit;

  // string value into IPortableDeviceValues object
  dev_val.fmtid := WPD_OBJECT_ID_FMTID;
  dev_val.pid := WPD_OBJECT_ID_PID;
  pValues.SetStringValue(dev_val, PWideChar(sVal));

  // get back string into a PROPVARIANT
  pValues.GetValue(dev_val, propvarValue);

  pValues := nil;
end;

procedure PropVariantToString(propvarValue: tag_inner_PROPVARIANT; var sVal: WideString);
var
  pValues: IPortableDeviceValues;
  dev_val: PortableDeviceApiLib_TLB._tagpropertykey;
  hr: HResult;
  pVal: PWideChar;
begin
  sVal := '';
  pValues :=  CreateComObject(CLASS_PortableDeviceValues) as IPortableDeviceValues;
  if VarIsClear(pValues) then Exit;

  // PROPVARIANT into IPortableDeviceValues object
  dev_val.fmtid := WPD_OBJECT_ID_FMTID;
  dev_val.pid := WPD_OBJECT_ID_PID;
  pValues.SetValue(dev_val, propvarValue);

  //check if it is error code
  if propvarValue.vt = VT_ERROR then
  begin
    pValues.GetErrorValue(dev_val, hr);
    sVal := SysErrorMessage(hr);
  end
  else
  begin
    // get back string
    pValues.GetStringValue(dev_val, pVal);
    sVal := pVal;
  end;

  pValues := nil;
end;

function GetDevDescription(PMan: TPortableDeviceManager; sDeviceId: WideString): WideString;
var
  iDevNameLen: LongWord;
  iRes: Integer;
begin
  //get length of friendly name:
  iDevNameLen := 0;
  Result := '';

  iRes := PMan.GetDeviceDescription(PWideChar(sDeviceId), Word(nil^), iDevNameLen);
  if iRes = S_OK then
  begin
    Form12.AddLog('DeviceDescription len='+IntToStr(iDevNameLen));

    //Get Description
    if iDevNameLen>0 then
    begin
      SetLength(Result, iDevNameLen);
      ZeroMemory(PWideChar(Result), iDevNameLen);
      PMan.GetDeviceDescription(PWideChar(sDeviceId), PWord(PWideChar(Result))^, iDevNameLen);
      Result := Trim(Result);
      Form12.AddLog('DeviceDescription='+Result);
    end;
  end
  else
  begin
    Form12.AddLog('Cannot GetDeviceDescription! ('+IntToStr(iRes)+')');
  end;
end;

function GetFriendlyName(PMan: TPortableDeviceManager; sDeviceId: WideString): WideString;
var
  iDevNameLen{, iType}: LongWord;
  iRes: Integer;
begin
  //get length of friendly name:
  iDevNameLen := 0;
  Result := '';

  iRes := PMan.GetDeviceFriendlyName(PWideChar(sDeviceId), Word(nil^), iDevNameLen);
  if iRes = S_OK then
  begin
    Form12.AddLog('FriendlyName len='+IntToStr(iDevNameLen));

    //Get Friendly Name
    if iDevNameLen>0 then
    begin
      SetLength(Result, iDevNameLen);
      ZeroMemory(PWideChar(Result), iDevNameLen);
      PMan.GetDeviceFriendlyName(PWideChar(sDeviceId), PWord(PWideChar(Result))^, iDevNameLen);
      Result := Trim(Result);
      Form12.AddLog('FriendlyName='+Result);
    end;
  end
  else
  begin
    Form12.AddLog('Cannot GetDeviceFriendlyName! ('+IntToStr(iRes)+')');

    Result := GetDevDescription(PMan, sDeviceId);

    //test code - non working
    {if Result = '' then
    begin
      iDevNameLen := 200;

      iType := REG_SZ;
      //if PMan.GetDeviceProperty(PWideChar(sDeviceId), 'LocationInformation', Byte(nil^), iDevNameLen, iType) = S_OK then
      begin
        Form12.AddLog('DeviceName len='+IntToStr(iDevNameLen));

        //Get Friendly Name
        if iDevNameLen>0 then
        begin
          SetLength(Result, iDevNameLen);
          ZeroMemory(PWideChar(Result), iDevNameLen);
          PMan.GetDeviceProperty(PWideChar(sDeviceId), 'DeviceModel', PByte(PWideChar(Result))^, iDevNameLen, iType);
          Result := Trim(Result);
          Form12.AddLog('DeviceName='+Result);
        end;
      end;
    end;}
  end;
end;

function DisplayObjectFormatDesc(format_id: WideString): String;
var
  g: TGuid;
begin
  Result := format_id;
  if format_id='' then Exit;

  try
    g := StringToGUID(format_id);

    if IsEqualGUID(WPD_OBJECT_FORMAT_3GP, g) then Result := 'WPD_OBJECT_FORMAT_3GP'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_AAC, g) then Result := 'WPD_OBJECT_FORMAT_AAC'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_ABSTRACT_CONTACT, g) then Result := 'WPD_OBJECT_FORMAT_ABSTRACT_CONTACT'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_ABSTRACT_CONTACT_GROUP, g) then Result := 'WPD_OBJECT_FORMAT_ABSTRACT_CONTACT_GROUP'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_ABSTRACT_MEDIA_CAST, g) then Result := 'WPD_OBJECT_FORMAT_ABSTRACT_MEDIA_CAST'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_AIFF, g) then Result := 'WPD_OBJECT_FORMAT_AIFF'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_ALL, g) then Result := 'WPD_OBJECT_FORMAT_ALL'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_ASF, g) then Result := 'WPD_OBJECT_FORMAT_ASF'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_ASXPLAYLIST, g) then Result := 'WPD_OBJECT_FORMAT_ASXPLAYLIST'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_AUDIBLE, g) then Result := 'WPD_OBJECT_FORMAT_AUDIBLE'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_AVI, g) then Result := 'WPD_OBJECT_FORMAT_AVI'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_BMP, g) then Result := 'WPD_OBJECT_FORMAT_BMP'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_CIFF, g) then Result := 'WPD_OBJECT_FORMAT_CIFF'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_DPOF, g) then Result := 'WPD_OBJECT_FORMAT_DPOF'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_EXECUTABLE, g) then Result := 'WPD_OBJECT_FORMAT_EXECUTABLE'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_EXIF, g) then Result := 'WPD_OBJECT_FORMAT_EXIF'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_FLAC, g) then Result := 'WPD_OBJECT_FORMAT_FLAC'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_FLASHPIX, g) then Result := 'WPD_OBJECT_FORMAT_FLASHPIX'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_GIF, g) then Result := 'WPD_OBJECT_FORMAT_GIF'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_HTML, g) then Result := 'WPD_OBJECT_FORMAT_HTML'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_ICALENDAR, g) then Result := 'WPD_OBJECT_FORMAT_ICALENDAR'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_ICON, g) then Result := 'WPD_OBJECT_FORMAT_ICON'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_JFIF, g) then Result := 'WPD_OBJECT_FORMAT_JFIF'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_JP2, g) then Result := 'WPD_OBJECT_FORMAT_JP2'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_JPX, g) then Result := 'WPD_OBJECT_FORMAT_JPX'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_M3UPLAYLIST, g) then Result := 'WPD_OBJECT_FORMAT_M3UPLAYLIST'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_M4A, g) then Result := 'WPD_OBJECT_FORMAT_M4A'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_MHT_COMPILED_HTML, g) then Result := 'WPD_OBJECT_FORMAT_MHT_COMPILED_HTML'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_MICROSOFT_EXCEL, g) then Result := 'WPD_OBJECT_FORMAT_MICROSOFT_EXCEL'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_MICROSOFT_POWERPOINT, g) then Result := 'WPD_OBJECT_FORMAT_MICROSOFT_POWERPOINT'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_MICROSOFT_WFC, g) then Result := 'WPD_OBJECT_FORMAT_MICROSOFT_WFC'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_MICROSOFT_WORD, g) then Result := 'WPD_OBJECT_FORMAT_MICROSOFT_WORD'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_MP2, g) then Result := 'WPD_OBJECT_FORMAT_MP2'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_MP3, g) then Result := 'WPD_OBJECT_FORMAT_MP3'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_MP4, g) then Result := 'WPD_OBJECT_FORMAT_MP4'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_MPEG, g) then Result := 'WPD_OBJECT_FORMAT_MPEG'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_MPLPLAYLIST, g) then Result := 'WPD_OBJECT_FORMAT_MPLPLAYLIST'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_NETWORK_ASSOCIATION, g) then Result := 'WPD_OBJECT_FORMAT_NETWORK_ASSOCIATION'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_OGG, g) then Result := 'WPD_OBJECT_FORMAT_OGG'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_PCD, g) then Result := 'WPD_OBJECT_FORMAT_PCD'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_PICT, g) then Result := 'WPD_OBJECT_FORMAT_PICT'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_PLSPLAYLIST, g) then Result := 'WPD_OBJECT_FORMAT_PLSPLAYLIST'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_PNG, g) then Result := 'WPD_OBJECT_FORMAT_PNG'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_PROPERTIES_ONLY, g) then Result := 'WPD_OBJECT_FORMAT_PROPERTIES_ONLY'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_SCRIPT, g) then Result := 'WPD_OBJECT_FORMAT_SCRIPT'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_TEXT, g) then Result := 'WPD_OBJECT_FORMAT_TEXT'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_TIFF, g) then Result := 'WPD_OBJECT_FORMAT_TIFF'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_TIFFEP, g) then Result := 'WPD_OBJECT_FORMAT_TIFFEP'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_TIFFIT, g) then Result := 'WPD_OBJECT_FORMAT_TIFFIT'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_UNSPECIFIED, g) then Result := 'WPD_OBJECT_FORMAT_UNSPECIFIED'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_VCALENDAR1, g) then Result := 'WPD_OBJECT_FORMAT_VCALENDAR1'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_VCARD2, g) then Result := 'WPD_OBJECT_FORMAT_VCARD2'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_VCARD3, g) then Result := 'WPD_OBJECT_FORMAT_VCARD3'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_WAVE, g) then Result := 'WPD_OBJECT_FORMAT_WAVE'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_WINDOWSIMAGEFORMAT, g) then Result := 'WPD_OBJECT_FORMAT_WINDOWSIMAGEFORMAT'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_WMA, g) then Result := 'WPD_OBJECT_FORMAT_WMA'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_WMV, g) then Result := 'WPD_OBJECT_FORMAT_WMV'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_WPLPLAYLIST, g) then Result := 'WPD_OBJECT_FORMAT_WPLPLAYLIST'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_X509V3CERTIFICATE, g) then Result := 'WPD_OBJECT_FORMAT_X509V3CERTIFICATE'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_XML, g) then Result := 'WPD_OBJECT_FORMAT_XML'
    else if IsEqualGUID(WPD_OBJECT_FORMAT_WMV, g) then Result := 'WPD_OBJECT_FORMAT_WMV';
  except
  end;
end;

function DisplayFunctionalCategory(cat_id: WideString): String;
var
  g: TGuid;
begin
  Result := cat_id;
  if cat_id='' then Exit;

  try
    g := StringToGUID(cat_id);

    if IsEqualGUID(WPD_FUNCTIONAL_CATEGORY_ALL, g) then Result := 'WPD_FUNCTIONAL_CATEGORY_ALL'
    else if IsEqualGUID(WPD_FUNCTIONAL_CATEGORY_AUDIO_CAPTURE, g) then Result := 'WPD_FUNCTIONAL_CATEGORY_AUDIO_CAPTURE'
    else if IsEqualGUID(WPD_FUNCTIONAL_CATEGORY_DEVICE, g) then Result := 'WPD_FUNCTIONAL_CATEGORY_DEVICE'
    else if IsEqualGUID(WPD_FUNCTIONAL_CATEGORY_NETWORK_CONFIGURATION, g) then Result := 'WPD_FUNCTIONAL_CATEGORY_NETWORK_CONFIGURATION'
    else if IsEqualGUID(WPD_FUNCTIONAL_CATEGORY_RENDERING_INFORMATION, g) then Result := 'WPD_FUNCTIONAL_CATEGORY_RENDERING_INFORMATION'
    else if IsEqualGUID(WPD_FUNCTIONAL_CATEGORY_SMS, g) then Result := 'WPD_FUNCTIONAL_CATEGORY_SMS'
    else if IsEqualGUID(WPD_FUNCTIONAL_CATEGORY_STILL_IMAGE_CAPTURE, g) then Result := 'WPD_FUNCTIONAL_CATEGORY_STILL_IMAGE_CAPTURE'
    else if IsEqualGUID(WPD_FUNCTIONAL_CATEGORY_STORAGE, g) then Result := 'WPD_FUNCTIONAL_CATEGORY_STORAGE'
    else if IsEqualGUID(WPD_FUNCTIONAL_CATEGORY_VIDEO_CAPTURE, g) then Result := 'WPD_FUNCTIONAL_CATEGORY_VIDEO_CAPTURE';
  except
  end;
end;

function DisplayContentType(content_id: WideString): String;
var
  g: TGuid;
begin
  Result := content_id;
  if content_id='' then Exit;

  try
    g := StringToGUID(content_id);

    if IsEqualGUID(WPD_CONTENT_TYPE_ALL, g) then Result := 'WPD_CONTENT_TYPE_ALL'
    else if IsEqualGUID(WPD_CONTENT_TYPE_APPOINTMENT, g) then Result := 'WPD_CONTENT_TYPE_APPOINTMENT'
    else if IsEqualGUID(WPD_CONTENT_TYPE_AUDIO, g) then Result := 'WPD_CONTENT_TYPE_AUDIO'
    else if IsEqualGUID(WPD_CONTENT_TYPE_AUDIO_ALBUM, g) then Result := 'WPD_CONTENT_TYPE_AUDIO_ALBUM'
    else if IsEqualGUID(WPD_CONTENT_TYPE_CALENDAR, g) then Result := 'WPD_CONTENT_TYPE_CALENDAR'
    else if IsEqualGUID(WPD_CONTENT_TYPE_CERTIFICATE, g) then Result := 'WPD_CONTENT_TYPE_CERTIFICATE'
    else if IsEqualGUID(WPD_CONTENT_TYPE_CONTACT, g) then Result := 'WPD_CONTENT_TYPE_CONTACT'
    else if IsEqualGUID(WPD_CONTENT_TYPE_CONTACT_GROUP, g) then Result := 'WPD_CONTENT_TYPE_CONTACT_GROUP'
    else if IsEqualGUID(WPD_CONTENT_TYPE_DOCUMENT, g) then Result := 'WPD_CONTENT_TYPE_DOCUMENT'
    else if IsEqualGUID(WPD_CONTENT_TYPE_EMAIL, g) then Result := 'WPD_CONTENT_TYPE_EMAIL'
    else if IsEqualGUID(WPD_CONTENT_TYPE_FUNCTIONAL_OBJECT, g) then Result := 'WPD_CONTENT_TYPE_FUNCTIONAL_OBJECT'
    else if IsEqualGUID(WPD_CONTENT_TYPE_GENERIC_FILE, g) then Result := 'WPD_CONTENT_TYPE_GENERIC_FILE'
    else if IsEqualGUID(WPD_CONTENT_TYPE_GENERIC_MESSAGE, g) then Result := 'WPD_CONTENT_TYPE_GENERIC_MESSAGE'
    else if IsEqualGUID(WPD_CONTENT_TYPE_IMAGE, g) then Result := 'WPD_CONTENT_TYPE_IMAGE'
    else if IsEqualGUID(WPD_CONTENT_TYPE_IMAGE_ALBUM, g) then Result := 'WPD_CONTENT_TYPE_IMAGE_ALBUM'
    else if IsEqualGUID(WPD_CONTENT_TYPE_MEDIA_CAST, g) then Result := 'WPD_CONTENT_TYPE_MEDIA_CAST'
    else if IsEqualGUID(WPD_CONTENT_TYPE_MEMO, g) then Result := 'WPD_CONTENT_TYPE_MEMO'
    else if IsEqualGUID(WPD_CONTENT_TYPE_MIXED_CONTENT_ALBUM, g) then Result := 'WPD_CONTENT_TYPE_MIXED_CONTENT_ALBUM'
    else if IsEqualGUID(WPD_CONTENT_TYPE_NETWORK_ASSOCIATION, g) then Result := 'WPD_CONTENT_TYPE_NETWORK_ASSOCIATION'
    else if IsEqualGUID(WPD_CONTENT_TYPE_PLAYLIST, g) then Result := 'WPD_CONTENT_TYPE_PLAYLIST'
    else if IsEqualGUID(WPD_CONTENT_TYPE_PROGRAM, g) then Result := 'WPD_CONTENT_TYPE_PROGRAM'
    else if IsEqualGUID(WPD_CONTENT_TYPE_SECTION, g) then Result := 'WPD_CONTENT_TYPE_SECTION'
    else if IsEqualGUID(WPD_CONTENT_TYPE_TASK, g) then Result := 'WPD_CONTENT_TYPE_TASK'
    else if IsEqualGUID(WPD_CONTENT_TYPE_TELEVISION, g) then Result := 'WPD_CONTENT_TYPE_TELEVISION'
    else if IsEqualGUID(WPD_CONTENT_TYPE_UNSPECIFIED, g) then Result := 'WPD_CONTENT_TYPE_UNSPECIFIED'
    else if IsEqualGUID(WPD_CONTENT_TYPE_VIDEO, g) then Result := 'WPD_CONTENT_TYPE_VIDEO'
    else if IsEqualGUID(WPD_CONTENT_TYPE_VIDEO_ALBUM, g) then Result := 'WPD_CONTENT_TYPE_VIDEO_ALBUM'
    else if IsEqualGUID(WPD_CONTENT_TYPE_WIRELESS_PROFILE, g) then Result := 'WPD_CONTENT_TYPE_WIRELESS_PROFILE'
    else if IsEqualGUID(WPD_CONTENT_TYPE_FOLDER, g) then Result := 'WPD_CONTENT_TYPE_FOLDER'
    ;
  except
  end;
end;

function DisplaySupportedCommand(g: TGuid): String;
begin
  Result := GUIDToString(g);

  try
    if IsEqualGUID(WPD_CATEGORY_COMMON, g) then Result := 'WPD_CATEGORY_COMMON'
    else if IsEqualGUID(WPD_CATEGORY_CAPABILITIES, g) then Result := 'WPD_CATEGORY_CAPABILITIES'
    else if IsEqualGUID(WPD_CATEGORY_DEVICE_HINTS, g) then Result := 'WPD_CATEGORY_DEVICE_HINTS'
    else if IsEqualGUID(WPD_CATEGORY_MEDIA_CAPTURE, g) then Result := 'WPD_CATEGORY_MEDIA_CAPTURE'
    else if IsEqualGUID(WPD_CATEGORY_NETWORK_CONFIGURATION, g) then Result := 'WPD_CATEGORY_NETWORK_CONFIGURATION'
    else if IsEqualGUID(WPD_CATEGORY_NULL, g) then Result := 'WPD_CATEGORY_NULL'
    else if IsEqualGUID(WPD_CATEGORY_OBJECT_ENUMERATION, g) then Result := 'WPD_CATEGORY_OBJECT_ENUMERATION'
    else if IsEqualGUID(WPD_CATEGORY_OBJECT_MANAGEMENT, g) then Result := 'WPD_CATEGORY_OBJECT_MANAGEMENT'
    else if IsEqualGUID(WPD_CATEGORY_OBJECT_PROPERTIES, g) then Result := 'WPD_CATEGORY_OBJECT_PROPERTIES'
    else if IsEqualGUID(WPD_CATEGORY_OBJECT_PROPERTIES_BULK, g) then Result := 'WPD_CATEGORY_OBJECT_PROPERTIES_BULK'
    else if IsEqualGUID(WPD_CATEGORY_OBJECT_RESOURCES, g) then Result := 'WPD_CATEGORY_OBJECT_RESOURCES'
    else if IsEqualGUID(WPD_CATEGORY_SERVICE_CAPABILITIES, g) then Result := 'WPD_CATEGORY_SERVICE_CAPABILITIES'
    else if IsEqualGUID(WPD_CATEGORY_SERVICE_COMMON, g) then Result := 'WPD_CATEGORY_SERVICE_COMMON'
    else if IsEqualGUID(WPD_CATEGORY_SERVICE_METHODS, g) then Result := 'WPD_CATEGORY_SERVICE_METHODS'
    else if IsEqualGUID(WPD_CATEGORY_SMS, g) then Result := 'WPD_CATEGORY_SMS'
    else if IsEqualGUID(WPD_CATEGORY_STILL_IMAGE_CAPTURE, g) then Result := 'WPD_CATEGORY_STILL_IMAGE_CAPTURE'
    else if IsEqualGUID(WPD_CATEGORY_STORAGE, g) then Result := 'WPD_CATEGORY_STORAGE'
    ;
  except
  end;
end;

procedure EnumContentsProperties(parentID: WideString; prop: IPortableDeviceProperties);
var
  ObjVal: PWideChar;
  propKeys: IPortableDeviceKeyCollection;
  prop_val: IPortableDeviceValues;
  propKeys_val: PortableDeviceApiLib_TLB._tagpropertykey;
begin
  if not VarIsClear(prop) then
  begin
    propKeys := CreateComObject(CLSID_PortableDeviceKeyCollection) as IPortableDeviceKeyCollection;
    if VarIsClear(propKeys) then Exit;

    //add props we want
    propKeys_val.fmtid := WPD_OBJECT_PARENT_ID_FMTID;
    propKeys_val.pid := WPD_OBJECT_PARENT_ID_PID;
    propKeys.Add(propKeys_val);

    propKeys_val.fmtid := WPD_OBJECT_NAME_FMTID;
    propKeys_val.pid := WPD_OBJECT_NAME_PID;
    propKeys.Add(propKeys_val);

    propKeys_val.fmtid := WPD_OBJECT_PERSISTENT_UNIQUE_ID_FMTID;
    propKeys_val.pid := WPD_OBJECT_PERSISTENT_UNIQUE_ID_PID;
    propKeys.Add(propKeys_val);

    propKeys_val.fmtid := WPD_OBJECT_FORMAT_FMTID;
    propKeys_val.pid := WPD_OBJECT_FORMAT_PID;
    propKeys.Add(propKeys_val);

    propKeys_val.fmtid := WPD_OBJECT_CONTENT_TYPE_FMTID;
    propKeys_val.pid := WPD_OBJECT_CONTENT_TYPE_PID;
    propKeys.Add(propKeys_val);

    prop.GetValues(PWideChar(parentID), propKeys, prop_val);
    if not VarIsClear(prop_val) then
    begin
      propKeys_val.fmtid := WPD_OBJECT_PARENT_ID_FMTID;
      propKeys_val.pid := WPD_OBJECT_PARENT_ID_PID;

      prop_val.GetStringValue(propKeys_val, ObjVal);
      Form12.AddLog('WPD_OBJECT_PARENT_ID: '+ ObjVal);

      propKeys_val.fmtid := WPD_OBJECT_NAME_FMTID;
      propKeys_val.pid := WPD_OBJECT_NAME_PID;

      prop_val.GetStringValue(propKeys_val, ObjVal);
      Form12.AddLog('WPD_OBJECT_NAME: '+ ObjVal);

      propKeys_val.fmtid := WPD_OBJECT_PERSISTENT_UNIQUE_ID_FMTID;
      propKeys_val.pid := WPD_OBJECT_PERSISTENT_UNIQUE_ID_PID;

      prop_val.GetStringValue(propKeys_val, ObjVal);
      Form12.AddLog('WPD_OBJECT_PERSISTENT_UNIQUE_ID: '+ ObjVal);

      propKeys_val.fmtid := WPD_OBJECT_FORMAT_FMTID;
      propKeys_val.pid := WPD_OBJECT_FORMAT_PID;

      prop_val.GetStringValue(propKeys_val, ObjVal);
      Form12.AddLog('WPD_OBJECT_FORMAT: '+ DisplayObjectFormatDesc(ObjVal));

      propKeys_val.fmtid := WPD_OBJECT_CONTENT_TYPE_FMTID;
      propKeys_val.pid := WPD_OBJECT_CONTENT_TYPE_PID;

      prop_val.GetStringValue(propKeys_val, ObjVal);
      Form12.AddLog('WPD_OBJECT_CONTENT_TYPE: '+ DisplayContentType(ObjVal));
    end;
  end;
end;

procedure EnumFunctionalCategoryObjects(capabilities: IPortableDeviceCapabilities; sCat: WideString);
var
  sResultText: WideString;
  pCategoryObjs: IPortableDevicePropVariantCollection;
  iCount, i: Cardinal;
  prop_var: tag_inner_PROPVARIANT;
  gCat: TGuid;
begin
  if sCat='' then Exit;

  if not VarIsClear(capabilities) then
  begin
    gCat := StringToGUID(sCat);
    try
      pCategoryObjs := CreateComObject(CLASS_PortableDevicePropVariantCollection) as IPortableDevicePropVariantCollection;
      if VarIsClear(pCategoryObjs) then Exit;

      capabilities.GetFunctionalObjects(gCat, pCategoryObjs);

      pCategoryObjs.GetCount(iCount);
      Form12.AddLog('Functional Category Objects Count: '+IntToStr(iCount));

      if iCount>0 then
      begin
        for i := 0 to iCount-1 do
        begin
          PropVariantInit(ActiveX.PROPVARIANT(prop_var));
          pCategoryObjs.GetAt(i, prop_var);
          PropVariantToString(prop_var, sResultText);
          Form12.AddLog('Functional Category Object: '+sResultText);
        end;
      end;
    except
    end;
  end;
end;

procedure EnumContentTypes(capabilities: IPortableDeviceCapabilities; sCat: WideString);
var
  sResultText: WideString;
  contentTypes: IPortableDevicePropVariantCollection;
  iCount, i: Cardinal;
  prop_var: tag_inner_PROPVARIANT;
  gCat: TGuid;
begin
  if sCat='' then Exit;

  if not VarIsClear(capabilities) then
  begin
    gCat := StringToGUID(sCat);
    try
      contentTypes := CreateComObject(CLASS_PortableDevicePropVariantCollection) as IPortableDevicePropVariantCollection;
      if VarIsClear(contentTypes) then Exit;

      capabilities.GetSupportedContentTypes(gCat, contentTypes);

      contentTypes.GetCount(iCount);
      Form12.AddLog('Content Types Count: '+IntToStr(iCount));

      if iCount>0 then
      begin
        for i := 0 to iCount-1 do
        begin
          PropVariantInit(ActiveX.PROPVARIANT(prop_var));
          contentTypes.GetAt(i, prop_var);
          PropVariantToString(prop_var, sResultText);
          Form12.AddLog('Content Type: '+DisplayContentType(sResultText));
        end;
      end;
    except
    end;
  end;
end;

procedure EnumSupportedCommands(capabilities: IPortableDeviceCapabilities);
var
  CmdKeys: IPortableDeviceKeyCollection;
  iCount, i: Cardinal;
  cmd_key: PortableDeviceApiLib_TLB._tagpropertykey;
begin
  if not VarIsClear(capabilities) then
  begin
    try
      CmdKeys := CreateComObject(CLSID_PortableDeviceKeyCollection) as IPortableDeviceKeyCollection;
      if VarIsClear(CmdKeys) then Exit;

      capabilities.GetSupportedCommands(CmdKeys);

      CmdKeys.GetCount(iCount);
      Form12.AddLog('Supported Commands Count: '+IntToStr(iCount));

      if iCount>0 then
      begin
        for i := 0 to iCount-1 do
        begin
          CmdKeys.GetAt(i, cmd_key);
          Form12.AddLog('Supported Command: '+DisplaySupportedCommand(cmd_key.fmtid)+' ('+IntToStr(cmd_key.pid)+')');
        end;
      end;
    except
    end;
  end;
end;

procedure EnumDevCapabilities(PortableDev: IPortableDevice);
var
  sResultText: WideString;
  capabilities: IPortableDeviceCapabilities;
  pCategories: IPortableDevicePropVariantCollection;
  iCount, i: Cardinal;
  prop_var: tag_inner_PROPVARIANT;
begin
  if not VarIsClear(PortableDev) then
  begin
    try
      PortableDev.Capabilities(capabilities);
      if not VarIsClear(capabilities) then
      begin
        pCategories := CreateComObject(CLASS_PortableDevicePropVariantCollection) as IPortableDevicePropVariantCollection;
        if VarIsClear(pCategories) then Exit;

        capabilities.GetFunctionalCategories(pCategories);

        pCategories.GetCount(iCount);
        Form12.AddLog('Dev. Functional Categories Count: '+IntToStr(iCount));

        if iCount>0 then
        begin
          for i := 0 to iCount-1 do
          begin
            //list categories
            PropVariantInit(ActiveX.PROPVARIANT(prop_var));
            pCategories.GetAt(i, prop_var);
            PropVariantToString(prop_var, sResultText);
            Form12.AddLog('Dev. Functional Category: '+DisplayFunctionalCategory(sResultText));
            //category objects....
            EnumFunctionalCategoryObjects(capabilities, sResultText);
            //types...
            EnumContentTypes(capabilities, sResultText);
          end;
        end;
        //comands....
        EnumSupportedCommands(capabilities);
      end;
    finally
      capabilities := nil;
    end;
  end;
end;

const
  CLIENT_NAME : WideString = 'MyClient';
  CLIENT_MAJOR_VER = 1;
  CLIENT_MINOR_VER = 0;
  CLIENT_REVISION  = 0;

function ConnectToDevice(sDev: WideString; var PortableDev: IPortableDevice): Boolean;
var
  PortableDeviceValues: IPortableDeviceValues;
  hr: HResult;
  dev_val: PortableDeviceApiLib_TLB._tagpropertykey;
  //bReadonly: Boolean;
begin
  Result := False;

  Form12.AddLog('Start Connecting: '+sDev);

  PortableDev := CoPortableDevice.Create;
  try
     //create device values:
    PortableDeviceValues := CreateComObject(CLASS_PortableDeviceValues) as IPortableDeviceValues;
    if VarIsClear(PortableDeviceValues) then Exit;
    Form12.AddLog('Dev. val. ok! ');

    //bReadonly := False;
    //set some info
    dev_val.fmtid := WPD_CLIENT_NAME_FMTID;
    dev_val.pid := WPD_CLIENT_NAME_PID;
    PortableDeviceValues.SetStringValue(dev_val, PWideChar(CLIENT_NAME));

    dev_val.fmtid := WPD_CLIENT_MAJOR_VERSION_FMTID;
    dev_val.pid := WPD_CLIENT_MAJOR_VERSION_PID;
    PortableDeviceValues.SetUnsignedIntegerValue(dev_val, CLIENT_MAJOR_VER);

    dev_val.fmtid := WPD_CLIENT_MINOR_VERSION_FMTID;
    dev_val.pid := WPD_CLIENT_MINOR_VERSION_PID;
    PortableDeviceValues.SetUnsignedIntegerValue(dev_val, CLIENT_MINOR_VER);

    dev_val.fmtid := WPD_CLIENT_REVISION_FMTID;
    dev_val.pid := WPD_CLIENT_REVISION_PID;
    PortableDeviceValues.SetUnsignedIntegerValue(dev_val, CLIENT_REVISION);

    //open device
    hr := PortableDev.Open(PWideChar(sDev), PortableDeviceValues);
    if hr = E_ACCESSDENIED then
    begin
      // Attempt to open for read-only access
      dev_val.fmtid := WPD_CLIENT_DESIRED_ACCESS_FMTID;
      dev_val.pid := WPD_CLIENT_DESIRED_ACCESS_PID;
      PortableDeviceValues.SetUnsignedIntegerValue(dev_val, GENERIC_READ);
      hr := PortableDev.Open(PWideChar(sDev), PortableDeviceValues);
      //bReadonly := (hr = S_OK);
    end;

    //opened ok
    if hr = S_OK then
    begin
      Form12.AddLog('Connected: '+sDev);
      Result := True;
    end
    else
    begin
      Form12.AddLog('Not connected: '+IntToStr(hr));
    end;
  finally
    PortableDeviceValues := nil;
  end;
end;

procedure TForm12.Button1Click(Sender: TObject);
var
  PMan: TPortableDeviceManager;
  iDevCount: LongWord;
  pDevs: array of PWideChar;
  i, iRes: Integer;
  DevFriendlyName: WideString;
  PortableDev: IPortableDevice;
begin
  ClearLog;
  ListBox1.Items.Clear;
  ListView1.Items.Clear;
  AddLog('+++++ '+Button1.Caption+' +++++');

  try
    PMan := TPortableDeviceManager.Create(nil);
    try
      if PMan.RefreshDeviceList = S_OK then
      begin
        // Determine how many WPD devices are connected
        iDevCount := 1;
        if PMan.GetDevices(PWideChar(nil^), iDevCount) = S_OK then
        begin
          AddLog('Devices found: '+ IntToStr(iDevCount));

          if iDevCount>0 then
          begin
            // Retrieve the device id for each connected device
            AddLog('Prepare dev. list');
            SetLength(pDevs, iDevCount);
            AddLog('Call: GetDevices');
            iRes := PMan.GetDevices(pDevs[0], iDevCount);
            AddLog('Result = '+ IntToStr(iRes));
            if iRes = S_OK then
            begin
              AddLog('Start looping....');
              for i := 0 to iDevCount - 1 do //enumerate the devices:
              begin
                AddLog('dev id='+Trim(pDevs[i]));

                //get length of friendly name:
                DevFriendlyName := GetFriendlyName(PMan, pDevs[i]);

                ListBox1.Items.Add(DevFriendlyName + '  ' + Trim(pDevs[i])); //keep dev id 4 later

                //list of cap.
                try
                  if ConnectToDevice(pDevs[i], PortableDev) then
                  begin
                    EnumDevCapabilities(PortableDev);
                    PortableDev.Close;
                  end;
                finally
                  PortableDev := nil;
                end;
              end;
            end
            else
              AddLog('Cannot get device info! ('+IntToStr(iRes)+')');
          end;
        end;
      end;
    finally
      PMan.Free;
    end;
  except
    on E: Exception do
    begin
      AddLog('Exception: ('+E.Message+')');
    end;
  end;

  if ListBox1.Items.Count>0 then
    ListBox1.ItemIndex := 0;
end;

function IsDirectory(prop_val: IPortableDeviceValues): Boolean;
var
  dev_val: PortableDeviceApiLib_TLB._tagpropertykey;
  prop_guid: TGUID;
begin
  Result := False;

  if not VarIsClear(prop_val) then
  begin
    dev_val.fmtid := WPD_OBJECT_CONTENT_TYPE_FMTID;
    dev_val.pid := WPD_OBJECT_CONTENT_TYPE_PID;
    if prop_val.GetGuidValue(dev_val, prop_guid) = S_OK then
    begin
      if IsEqualGUID(prop_guid, WPD_CONTENT_TYPE_FOLDER) or
        IsEqualGUID(prop_guid, WPD_CONTENT_TYPE_FUNCTIONAL_OBJECT)
      then
        Result := True;
    end;
  end;
end;

function IsDrive(sObjName: WideString): Boolean;
begin
  Result := (ExtractFilePath(sObjName) = sObjName);
end;

function GetFirstStorageID(PortableDev: IPortableDevice): WideString;
var
  content: IPortableDeviceContent;
  objectIds: IEnumPortableDeviceObjectIDs;
  objectId: PWideChar;
  fetched: Cardinal;
begin
  Result := WPD_DEVICE_OBJECT_ID;
  if PortableDev.Content(content) = S_OK then
  begin
    if content.EnumObjects(0, '', nil, objectIds) = S_OK then
    begin
      objectIds.Reset;
      objectIds.Next(1, objectId, fetched);
      if (fetched > 0) then
        Result := objectId;
    end;
  end;
  
  Form12.AddLog('Device root: '+ Result);
end;

procedure EnumContentsOfFolder(content: IPortableDeviceContent; parentID: WideString;
  lst: TListItems; bGoDeep: Boolean; ParentPath: WideString);
var
  objectIds: IEnumPortableDeviceObjectIDs;
  objectId, ObjName, ObjOrigName: PWideChar;
  fetched, total: Cardinal;
  keys: IPortableDeviceKeyCollection;
  prop: IPortableDeviceProperties;
  prop_val: IPortableDeviceValues;
  dev_val: PortableDeviceApiLib_TLB._tagpropertykey;
  bFolder: Boolean;
  itm: TListItem;
  //prop_guid: TGUID;
  ObjectPath: WideString;
begin
  if not VarIsClear(content) then
  begin
    //get content properties
    content.Properties(prop);
    EnumContentsProperties(parentID, prop);

    if content.EnumObjects(0, PWideChar(parentID), nil, objectIds) = S_OK then
    begin
      total := 0;
      Form12.AddLog('Enumerate: '+parentID);
      repeat
        objectIds.Next(1, objectId, fetched);
        Inc(total, fetched);
      until fetched=0;
      Form12.AddLog('Enum count: '+IntToStr(total));

      objectIds.Reset;
      repeat
        objectIds.Next(1, objectId, fetched);
        if (fetched > 0) then
        begin
          //Get object prop.
          prop.GetSupportedProperties(objectId, keys);
          prop.GetValues(objectId, keys, prop_val);
          ObjName := '';
          ObjOrigName := '';

          // Get the name of the object
          if not VarIsClear(prop_val) then
          begin
            dev_val.fmtid := WPD_OBJECT_ORIGINAL_FILE_NAME_FMTID;
            dev_val.pid := WPD_OBJECT_ORIGINAL_FILE_NAME_PID;

            prop_val.GetStringValue(dev_val, ObjOrigName);
            if Length(Trim(ObjOrigName)) = 0 then
              ObjOrigName := objectId;

            dev_val.fmtid := WPD_OBJECT_NAME_FMTID;
            dev_val.pid := WPD_OBJECT_NAME_PID;

            prop_val.GetStringValue(dev_val, ObjName);
          end;

          bFolder := IsDirectory(prop_val); //include zip folders
          if Length(ParentPath) > 0 then
            ObjectPath := IncludeTrailingPathDelimiter(ParentPath) + ObjName
          else
            ObjectPath := ObjName;

          //keep name
          itm := lst.Add;
          itm.Caption := ObjOrigName; //keep folder/file name
          itm.SubItems.Add(objectId);  //obj id - full path to object
          itm.SubItems.Add(ObjName); //obj name
          itm.SubItems.Add(ObjectPath); //full path to object
          itm.Data := Pointer(ifthen(bFolder, 1, 0));

          //go into subfolder
          if bFolder and bGoDeep then
          begin
            Form12.AddLog('Go deep...');
            EnumContentsOfFolder(content, objectId, lst, bGoDeep, ObjectPath);
          end;
        end;
      until fetched=0;
    end;
  end;
end;

function LocateSpecifiedFolder(content: IPortableDeviceContent; parentID: WideString;
  sFindFolder, sParent: WideString; var sDestFolder: WideString): Boolean;
var
  objectIds: IEnumPortableDeviceObjectIDs;
  objectId, ObjName, ObjOrigName: PWideChar;
  fetched, total: Cardinal;
  keys: IPortableDeviceKeyCollection;
  prop: IPortableDeviceProperties;
  prop_val: IPortableDeviceValues;
  dev_val: PortableDeviceApiLib_TLB._tagpropertykey;
  bFolder: Boolean;
  sCurrent: WideString;
begin
  Result := False;

  if (not VarIsClear(content)) and (Length(sFindFolder) > 0) then
  begin
    //get content properties
    content.Properties(prop);
    EnumContentsProperties(parentID, prop);

    if content.EnumObjects(0, PWideChar(parentID), nil, objectIds) = S_OK then
    begin
      total := 0;
      Form12.AddLog('Enumerate: '+parentID);
      repeat
        objectIds.Next(1, objectId, fetched);
        Inc(total, fetched);
      until fetched=0;
      Form12.AddLog('Enum count: '+IntToStr(total));

      objectIds.Reset;
      repeat
        objectIds.Next(1, objectId, fetched);
        if (fetched > 0) then
        begin
          //Get object prop.
          prop.GetSupportedProperties(objectId, keys);
          prop.GetValues(objectId, keys, prop_val);
          ObjName := '';
          ObjOrigName := '';

          // Get the name of the object
          if not VarIsClear(prop_val) then
          begin
            dev_val.fmtid := WPD_OBJECT_ORIGINAL_FILE_NAME_FMTID;
            dev_val.pid := WPD_OBJECT_ORIGINAL_FILE_NAME_PID;

            prop_val.GetStringValue(dev_val, ObjOrigName);
            if Length(Trim(ObjOrigName)) = 0 then
              ObjOrigName := objectId;

            dev_val.fmtid := WPD_OBJECT_NAME_FMTID;
            dev_val.pid := WPD_OBJECT_NAME_PID;

            prop_val.GetStringValue(dev_val, ObjName);
          end;

          bFolder := IsDirectory(prop_val); //include zip folders
          if sParent<>'' then        
            sCurrent := IncludeTrailingPathDelimiter(sParent)+ObjOrigName
          else
            sCurrent := ObjOrigName;

          if Pos(UpperCase(sCurrent), UpperCase(sFindFolder)) > 0 then
          begin
            if Length(sCurrent) >= Length(sFindFolder) then
            begin
              sDestFolder := objectId;
              Result := True;
            end
            else
            begin
              //go into subfolder
              if bFolder then
              begin
                Form12.AddLog('Go deep...');
                Result := LocateSpecifiedFolder(content, objectId, sFindFolder,
                  sCurrent, sDestFolder);
              end;
            end;
          end;
        end;
      until fetched=0;
    end;
  end;
end;

procedure ListFilesOnDevice(sDev: WideString; lst: TListItems; sParent: WideString;
  bGoDeep: Boolean);
var
  PortableDev: IPortableDevice;
  content: IPortableDeviceContent;
  sPath: String;
begin
  try
    if ConnectToDevice(sDev, PortableDev) then
    begin
      //read content of device
      try
        if PortableDev.Content(content) = S_OK then
        begin
          sPath := sParent;
          if sParent='' then
          begin
            sPath := '';
            sParent := GetFirstStorageID(PortableDev);
          end;

          EnumContentsOfFolder(content, sParent, lst, bGoDeep, sPath);
        end;
      finally
        PortableDev.Close;
      end;
    end;
  finally
    PortableDev := nil;
  end;
end;

function FindFolderOnDevice(sDev: WideString; sParent, sFindFolder: WideString;
  var sDestFolder: WideString): Boolean;
var
  PortableDev: IPortableDevice;
  content: IPortableDeviceContent;
begin
  Result := False;
  sDestFolder := '';
  try
    if ConnectToDevice(sDev, PortableDev) then
    begin
      //read content of device
      try
        if PortableDev.Content(content) = S_OK then
        begin
          if sParent='' then
            sParent := GetFirstStorageID(PortableDev);

          Result := LocateSpecifiedFolder(content, sParent, sFindFolder, '', sDestFolder);
        end;
      finally
        PortableDev.Close;
      end;
    end;
  finally
    PortableDev := nil;
  end;
end;

procedure TForm12.Button2Click(Sender: TObject);
var
  sDevId: WideString;
begin
  AddLog('+++++ '+Button2.Caption+' +++++');

  if ListBox1.ItemIndex >= 0 then
  begin
    //extract dev id
    sDevId := ListBox1.Items[ListBox1.ItemIndex];
    sDevId := Trim(Copy(sDevId, Pos(DEV_START_PATH, sDevId), Length(sDevId)));

    ListView1.Items.Clear;
    ListView1.Items.BeginUpdate;
    try
      ListFilesOnDevice(sDevId, ListView1.Items, '', True);
    finally
      ListView1.Items.EndUpdate;
    end;
  end;
end;

function GetFileFromDevice(sDeviceId, sFile, sSaveAs: WideString): Boolean;
var
  PortableDev: IPortableDevice;
  content: IPortableDeviceContent;
  resources: IPortableDeviceResources;
  iTransferSize, iReadBytes: Cardinal;
  res_prop: PortableDeviceApiLib_TLB._tagpropertykey;
  fDevStream: PortableDeviceApiLib_TLB.IStream;
  fFileStream: TFileStream;
  buf: array[0..(1024-1)] of Byte;
begin
  Result := False;
  try
    if ConnectToDevice(sDeviceId, PortableDev) then
    begin
      //read content of device
      try
        if PortableDev.Content(content) = S_OK then
        begin
          Form12.AddLog('Content: OK');

          if content.Transfer(resources) = S_OK then
          begin
            iTransferSize := 0;
            res_prop.fmtid := WPD_RESOURCE_DEFAULT_FMTID;
            res_prop.pid := WPD_RESOURCE_DEFAULT_PID;
            //request stream
            if resources.GetStream(PWideChar(sFile), res_prop, 0, iTransferSize, fDevStream) = S_OK then
            begin
              Form12.AddLog('Stream: OK');

              fFileStream := TFileStream.Create(sSaveAs, fmCreate);
              try
                //read source stream using buffer
                repeat
                  fDevStream.RemoteRead(buf[0], 1024, iReadBytes);
                  if iReadBytes>0 then
                    fFileStream.Write(buf[0], iReadBytes);
                until (iReadBytes = 0);

                Result := True;
              finally
                fFileStream.Free;
              end;
            end;
          end;
        end;
      finally
        fDevStream := nil;
        PortableDev.Close;
      end;
    end;
  finally
    PortableDev := nil;
  end;
end;

procedure TForm12.Button3Click(Sender: TObject);
var
  sDevId, sFile: WideString;
begin
  AddLog('+++++ '+Button3.Caption+' +++++');

  if (ListBox1.ItemIndex >= 0) and (ListView1.ItemIndex >= 0) and
    (Cardinal(ListView1.Items.Item[ListView1.ItemIndex].Data) = 0) then //if is file
  begin
    //extract dev id
    sDevId := ListBox1.Items[ListBox1.ItemIndex];
    sDevId := Trim(Copy(sDevId, Pos(DEV_START_PATH, sDevId), Length(sDevId)));
    //file id
    sFile := ListView1.Items.Item[ListView1.ItemIndex].SubItems[0];

    //get destination directory
    SaveDialog1.FileName := ExtractFileName(ListView1.Items.Item[ListView1.ItemIndex].Caption);
    if SaveDialog1.Execute then
    begin
      GetFileFromDevice(sDevId, sFile, SaveDialog1.FileName);
    end;
  end;
end;

function DelFileFromDevice(sDeviceId, sFile: WideString; bWithRecursion: Boolean;
  var sResultText: WideString): Boolean;
var
  PortableDev: IPortableDevice;
  content: IPortableDeviceContent;
  prop_var: tag_inner_PROPVARIANT;
  pFiles, pRes: IPortableDevicePropVariantCollection;
  iCount: Cardinal;
begin
  Result := False;
  sResultText := '';
  try
    if ConnectToDevice(sDeviceId, PortableDev) then
    begin
      //read content of device
      try
        if PortableDev.Content(content) = S_OK then
        begin
          pFiles := CreateComObject(CLASS_PortableDevicePropVariantCollection) as IPortableDevicePropVariantCollection;
          if VarIsClear(pFiles) then Exit;

          pRes := CreateComObject(CLASS_PortableDevicePropVariantCollection) as IPortableDevicePropVariantCollection;
          if VarIsClear(pRes) then Exit;

          //add  file name to list for deleting
          PropVariantInit(ActiveX.PROPVARIANT(prop_var));
          StringToPropVariant(sFile, prop_var);
          pFiles.Add(prop_var);

          Form12.AddLog('Try to delete: '+sFile);
          //delete
          Result := (content.Delete(Math.IfThen(bWithRecursion, 1, 0), pFiles, pRes) = S_OK); //recursion ??

          pRes.GetCount(iCount);
          if iCount>0 then
          begin
            PropVariantInit(ActiveX.PROPVARIANT(prop_var));
            pRes.GetAt(0, prop_var);
            PropVariantToString(prop_var, sResultText);

            Form12.AddLog('Delete: '+sResultText);
          end;
        end;
      finally
        PortableDev.Close;
      end;
    end;
  finally
    pFiles := nil;
    pRes := nil;
    PortableDev := nil;
  end;
end;

procedure TForm12.Button4Click(Sender: TObject);
var
  sDevId, sFile, sResultText: WideString;
begin
  AddLog('+++++ '+Button4.Caption+' +++++');

  if (ListBox1.ItemIndex >= 0) and (ListView1.ItemIndex >= 0) and
    (Cardinal(ListView1.Items.Item[ListView1.ItemIndex].Data) = 0) then  //if is file
  begin
    //extract dev id
    sDevId := ListBox1.Items[ListBox1.ItemIndex];
    sDevId := Trim(Copy(sDevId, Pos(DEV_START_PATH, sDevId), Length(sDevId)));
    //file
    sFile := ListView1.Items.Item[ListView1.ItemIndex].SubItems[0];

    //delete
    if MessageDlg('Want to delete?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      DelFileFromDevice(sDevId, sFile, True, sResultText);
      ShowMessage(sResultText);
    end;
  end;
end;

procedure GetRequiredPropertiesForContent(parent: WideString; FileName: WideString;
  iSize: Cardinal; var ppObjectProperties: IPortableDeviceValues);
var
  dev_val: PortableDeviceApiLib_TLB._tagpropertykey;
  //prop_guid: TGUID;
begin
  //parent id
  dev_val.fmtid := WPD_OBJECT_PARENT_ID_FMTID;
  dev_val.pid := WPD_OBJECT_PARENT_ID_PID;
  ppObjectProperties.SetStringValue(dev_val, PWideChar(parent));

  //object name
  dev_val.fmtid := WPD_OBJECT_NAME_FMTID;
  dev_val.pid := WPD_OBJECT_NAME_PID;
  ppObjectProperties.SetStringValue(dev_val, PWideChar(FileName));

  //file name
  dev_val.fmtid := WPD_OBJECT_ORIGINAL_FILE_NAME_FMTID;
  dev_val.pid := WPD_OBJECT_ORIGINAL_FILE_NAME_PID;
  ppObjectProperties.SetStringValue(dev_val, PWideChar(FileName));

  //size
  dev_val.fmtid := WPD_OBJECT_SIZE_FMTID;
  dev_val.pid := WPD_OBJECT_SIZE_PID;
  ppObjectProperties.SetUnsignedLargeIntegerValue(dev_val, iSize);

  {dev_val.fmtid := WPD_OBJECT_CONTENT_TYPE_FMTID;
  dev_val.pid := WPD_OBJECT_CONTENT_TYPE_PID;
  prop_guid := WPD_CONTENT_TYPE_FOLDER;
  ppObjectProperties.SetGuidValue(dev_val, prop_guid);}
end;

function TransferFileToDevice(sDeviceId, sFile, sSaveTo: WideString): Boolean;
var
  PortableDev: IPortableDevice;
  content: IPortableDeviceContent;
  iTransferSize, iReadBytes, iWritten: Cardinal;
  fDevStream: PortableDeviceApiLib_TLB.IStream;
  pValues: IPortableDeviceValues;
  fFileStream: TFileStream;
  buf: array[0..(1024-1)] of Byte;
  ppszCookie: PWideChar;
  iRes: Integer;
begin
  Result := False;
  try
    if ConnectToDevice(sDeviceId, PortableDev) then
    begin
      //read content of device
      try
        if PortableDev.Content(content) = S_OK then
        begin
          //required properties for content
          pValues :=  CreateComObject(CLASS_PortableDeviceValues) as IPortableDeviceValues;
          if VarIsClear(pValues) then Exit;

          Form12.AddLog('Try to copy to dev: '+sFile+ ' - dest: '+sSaveTo);

          fFileStream := TFileStream.Create(sFile, fmOpenRead);
          try
            GetRequiredPropertiesForContent(sSaveTo, ExtractFileName(sFile),
              fFileStream.Size, pValues);

            //create dest. stream
            iTransferSize := 0;
            content.CreateObjectWithPropertiesAndData(pValues, fDevStream, iTransferSize, ppszCookie);
            if VarIsClear(fDevStream) then Exit;

            Form12.AddLog('Stream: OK');

            //transfer to dev. stream
            //read source stream using buffer
            repeat
              iReadBytes := fFileStream.Read(buf[0], 1024);
              Form12.AddLog('File - readed bytes: ' + IntToStr(iReadBytes));
              if iReadBytes>0 then
              begin
               iRes := fDevStream.RemoteWrite(buf[0], iReadBytes, iWritten);
               if iRes <> S_OK then
                 Form12.AddLog('Error writing: ' + IntToStr(iRes));
              end;
            until (iReadBytes = 0);

            //commit saving to stream
            Result := (fDevStream.Commit(0) = S_OK);
            if Result then
              Form12.AddLog('File Commit ok!')
            else
              Form12.AddLog('File Commit nok!');
          finally
            fFileStream.Free;
          end;
        end;
      finally
        fDevStream := nil;
        PortableDev.Close;
      end;
    end;
  finally
    PortableDev := nil;
  end;
end;

procedure TForm12.Button5Click(Sender: TObject);
var
  sDevId, sFile, sFolder: WideString;
begin
  AddLog('+++++ '+Button5.Caption+' +++++');

  if (ListBox1.ItemIndex >= 0) then
  begin
    //extract dev id
    sDevId := ListBox1.Items[ListBox1.ItemIndex];
    sDevId := Trim(Copy(sDevId, Pos(DEV_START_PATH, sDevId), Length(sDevId)));

    if OpenDialog1.Execute then
    begin
      //file
      sFile := OpenDialog1.FileName;
      //dest. folder
      sFolder := '';
      if (ListView1.ItemIndex >= 0) then
      begin
        //folder is marked in TObject
        sFolder := ListView1.Items.Item[ListView1.ItemIndex].SubItems[0];

        if Integer(ListView1.Items.Item[ListView1.ItemIndex].Data)=0 then //is no folder
        begin
          sFolder := ExcludeTrailingPathDelimiter(ExtractFilePath(sFolder));
        end;
      end
      else
      begin
        //get main folder ....
        if ListView1.Items.Count > 0 then
        begin
          sFolder := ListView1.Items.Item[0].SubItems[0];
          sFolder := ExcludeTrailingPathDelimiter(ExtractFilePath(sFolder));
        end;
      end;

      AddLog('Want transfer to: ' + sFolder);

      //transfer to destination folder
      if TransferFileToDevice(sDevId, sFile, sFolder) then
        ShowMessage('Saved!')
      else
        ShowMessage('Error!');
    end;
  end;
end;

procedure TForm12.Button6Click(Sender: TObject);
var
  sDevId, sParent: WideString;
begin
  if Sender <> nil then
    AddLog('+++++ '+Button6.Caption+' +++++');
    
  if ListBox1.ItemIndex >= 0 then
  begin
    //extract dev id
    sDevId := ListBox1.Items[ListBox1.ItemIndex];
    sDevId := Trim(Copy(sDevId, Pos(DEV_START_PATH, sDevId), Length(sDevId)));

    sParent := '';
    if (ListView1.ItemIndex>=0) and (Sender = nil) then
    begin
      sParent := ListView1.Items.Item[ListView1.ItemIndex].SubItems[0];
      if Cardinal(ListView1.Items.Item[ListView1.ItemIndex].Data) = 0 then Exit;//is not folder
    end;

    ListView1.Items.Clear;
    ListView1.Items.BeginUpdate;
    try
      ListFilesOnDevice(sDevId, ListView1.Items, sParent, False);
    finally
      ListView1.Items.EndUpdate;
    end;
  end;
end;

procedure TForm12.Button7Click(Sender: TObject);
var
  sDevId, sFile, sFolder: WideString;
begin
  AddLog('+++++ '+Button7.Caption+' +++++');

  if (ListBox1.ItemIndex >= 0) then
  begin
    //extract dev id
    sDevId := ListBox1.Items[ListBox1.ItemIndex];
    sDevId := Trim(Copy(sDevId, Pos(DEV_START_PATH, sDevId), Length(sDevId)));

    if OpenDialog1.Execute then
    begin
      //file
      sFile := OpenDialog1.FileName;
      //dest. folder
      if FindFolderOnDevice(sDevId, '', Edit1.Text, sFolder) then
      begin
        AddLog('Folder found: ' + sFolder);
        //transfer to destination folder
        if TransferFileToDevice(sDevId, sFile, sFolder) then
          ShowMessage('Saved!')
        else
          ShowMessage('Error!');
      end
      else
        ShowMessage('Cannot locate destination folder!');
    end;
  end
  else
    ShowMessage('Please, select a device!');
end;

procedure TForm12.ListBox1DblClick(Sender: TObject);
begin
  Button6Click(Button6);
end;

procedure TForm12.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  DefaultDraw := True; //draw by default engine anyway
  Sender.Canvas.Font.Color := clBlack;

  if Cardinal(Item.Data) > 0 then //is folder?
  begin
    Sender.Canvas.Font.Color := clMaroon;
  end;
end;

procedure TForm12.ListView1DblClick(Sender: TObject);
begin
  //maybe file is dbl clked
  if (ListView1.ItemIndex >= 0) and (Cardinal(ListView1.Items.Item[ListView1.ItemIndex].Data) = 0) then
  begin
    Button3Click(nil);
  end
  else
  begin
    AddLog('+++++ List specific folder +++++');
    Button6Click(nil);
  end;
end;

procedure TForm12.ListView1DrawItem(Sender: TCustomListView; Item: TListItem;
  Rect: TRect; State: TOwnerDrawState);
begin
  //
end;

procedure TForm12.ListView1Editing(Sender: TObject; Item: TListItem;
  var AllowEdit: Boolean);
begin
  AllowEdit := False;
end;

initialization
  OleInitialize(nil);

finalization
  OleUninitialize;

end.
